# Copyright 2022-2024 ETSI SDG TeraFlowSDN (TFS) (https://tfs.etsi.org/)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import grpc, logging
from common.method_wrappers.Decorator import MetricsPool, safe_and_metered_rpc_method
from common.proto.context_pb2 import (
    ZtpFileName, ZtpFile, ProvisioningScriptName, ProvisioningScript)
from common.proto.ztpServer_pb2_grpc import ztpServerServiceServicer

LOGGER = logging.getLogger(__name__)

METRICS_POOL = MetricsPool('ZTP_SERVER', 'RPC')

class ZtpServerServiceServicerImpl(ztpServerServiceServicer):
    def __init__(self):
        LOGGER.info('Creating Servicer...')
        LOGGER.info('Servicer Created')

    @safe_and_metered_rpc_method(METRICS_POOL, LOGGER)
    def GetZtpProvisioning(self, request : ProvisioningScriptName, context : grpc.ServicerContext) -> ProvisioningScript:
        LOGGER.warning('NOT IMPLEMENTED')
        return ProvisioningScript()
    
    @safe_and_metered_rpc_method(METRICS_POOL, LOGGER)
    def GetZtpProvisioning(self, request : ZtpFileName, context : grpc.ServicerContext) -> ZtpFile:
        LOGGER.warning('NOT IMPLEMENTED')
        return ZtpFile()
    

